/* Tabela SEQNUMELOCA: Item do Lanamento de Estoque */
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na tabela SEQNUMELOCA */
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela SEQNUMELOCA utilizando a tabela Geral de Logs de Operaes */

CREATE OR REPLACE TRIGGER LOG_GER_CTRLNUMENF
AFTER DELETE OR INSERT OR UPDATE
ON CTRLNUMENF FOR EACH ROW
DECLARE
  V_USUARIO      VARCHAR2(40);
  V_TIPO         VARCHAR2(1);
  V_ITPESQ       VARCHAR2(40);
  V_DESC         VARCHAR2(300);
  V_DTOPER       DATE;
BEGIN
   V_TIPO := '0';
   V_DESC := '';

   IF DELETING THEN

      IF :OLD.CDCTRLNUMENF IS NOT NULL THEN
         V_DESC := V_DESC || 'Cod=' || :OLD.CDCTRLNUMENF;
      END IF;

      IF :OLD.DSCTRLNUMENF IS NOT NULL THEN
         V_DESC := V_DESC || ' Descrio=' || :OLD.DSCTRLNUMENF;
      END IF;

      IF :OLD.DTEMISCTNUNF IS NOT NULL THEN
         V_DESC := V_DESC || 'DataEmis=' || :OLD.DTEMISCTNUNF;
      END IF;

      IF :OLD.VRPEMINFRMNF IS NOT NULL THEN
         V_DESC := V_DESC || '  VrPEmin=' || :OLD.VRPEMINFRMNF;
      END IF;

      IF :OLD.IDCONSDTEMIS IS NOT NULL THEN
         V_DESC := V_DESC || 'ConsisteDtEmi=' || :OLD.IDCONSDTEMIS;
      END IF;

      IF :OLD.IDUTCTRLFORM IS NOT NULL THEN
         V_DESC := V_DESC || ' UtilizaCtrlForm=' || :OLD.IDUTCTRLFORM;
      END IF;

      IF :OLD.IDUTLOCAEMIS IS NOT NULL THEN
         V_DESC := V_DESC || ' UtilLocaEmis=' || :OLD.IDUTLOCAEMIS;
      END IF;

      IF :OLD.IDUTFILILCEM IS NOT NULL THEN
         V_DESC := V_DESC || ' UtilizaFil=' || :OLD.IDUTFILILCEM;
      END IF;

      V_TIPO         := '3';
      V_ITPESQ       := :OLD.CDCTRLNUMENF;
   ELSE
      IF UPDATING THEN
         IF (:OLD.CDCTRLNUMENF <> :NEW.CDCTRLNUMENF)  OR
            (NVL(:NEW.DSCTRLNUMENF,'!') <> NVL(:OLD.DSCTRLNUMENF, '!')) OR
            (NVL(:NEW.DTEMISCTNUNF,SYSDATE) <> NVL(:OLD.DTEMISCTNUNF, SYSDATE)) OR
            (NVL(:NEW.VRPEMINFRMNF,0)   <> NVL(:OLD.VRPEMINFRMNF, 0))   OR
            (NVL(:NEW.IDCONSDTEMIS,'!') <> NVL(:OLD.IDCONSDTEMIS, '!')) OR
            (NVL(:NEW.IDUTCTRLFORM,'!') <> NVL(:OLD.IDUTCTRLFORM, '!')) OR
            (NVL(:NEW.IDUTLOCAEMIS,'!') <> NVL(:OLD.IDUTLOCAEMIS, '!')) OR
            (NVL(:NEW.IDUTFILILCEM,'!') <> NVL(:OLD.IDUTFILILCEM, '!')) THEN

            IF :NEW.CDCTRLNUMENF IS NOT NULL THEN
               V_DESC := V_DESC || 'Cod=' || :NEW.CDCTRLNUMENF;
            END IF;

            IF (NVL(:NEW.DSCTRLNUMENF,'!') <> NVL(:OLD.DSCTRLNUMENF, '!')) THEN
               V_DESC := V_DESC || ' Descrio=' || :NEW.DSCTRLNUMENF;
            END IF;

            IF (NVL(:NEW.DTEMISCTNUNF,SYSDATE) <> NVL(:OLD.DTEMISCTNUNF, SYSDATE)) THEN
               V_DESC := V_DESC || 'DataEmis=' || :NEW.DTEMISCTNUNF;
            END IF;

            IF (NVL(:NEW.VRPEMINFRMNF,0) <> NVL(:OLD.VRPEMINFRMNF, 0)) THEN
               V_DESC := V_DESC || '  VrPEmin=' || :NEW.VRPEMINFRMNF;
            END IF;

            IF (NVL(:NEW.IDCONSDTEMIS,'!') <> NVL(:OLD.IDCONSDTEMIS, '!')) THEN
               V_DESC := V_DESC || 'ConsisteDtEmi=' || :NEW.IDCONSDTEMIS;
            END IF;

            IF (NVL(:NEW.IDUTCTRLFORM,'!') <> NVL(:OLD.IDUTCTRLFORM, '!')) THEN
               V_DESC := V_DESC || ' UtilizaCtrlForm=' || :NEW.IDUTCTRLFORM;
            END IF;

            IF (NVL(:NEW.IDUTLOCAEMIS,'!') <> NVL(:OLD.IDUTLOCAEMIS, '!')) THEN
               V_DESC := V_DESC || ' UtilLocaEmis=' || :NEW.IDUTLOCAEMIS;
            END IF;

            IF (NVL(:NEW.IDUTFILILCEM,'!') <> NVL(:OLD.IDUTFILILCEM, '!')) THEN
               V_DESC := V_DESC || ' UtilizaFil=' || :NEW.IDUTFILILCEM;
            END IF;

            V_TIPO         := '2';
            V_ITPESQ       := :OLD.CDCTRLNUMENF;
         END IF;
      ELSE
         IF :NEW.CDCTRLNUMENF IS NOT NULL THEN
            V_DESC := V_DESC || 'Cod=' || :NEW.CDCTRLNUMENF;
         END IF;

         IF :NEW.DSCTRLNUMENF IS NOT NULL THEN
            V_DESC := V_DESC || ' Descrio=' || :NEW.DSCTRLNUMENF;
         END IF;

         IF :NEW.DTEMISCTNUNF IS NOT NULL THEN
            V_DESC := V_DESC || 'DataEmis=' || :NEW.CDCTRLNUMENF;
         END IF;

         IF :NEW.VRPEMINFRMNF IS NOT NULL THEN
            V_DESC := V_DESC || '  VrPEmin=' || :NEW.VRPEMINFRMNF;
         END IF;

         IF :NEW.IDCONSDTEMIS IS NOT NULL THEN
            V_DESC := V_DESC || 'ConsisteDtEmi=' || :NEW.IDCONSDTEMIS;
         END IF;

         IF :NEW.IDUTCTRLFORM IS NOT NULL THEN
            V_DESC := V_DESC || ' UtilizaCtrlForm=' || :NEW.IDUTCTRLFORM;
         END IF;

         IF :NEW.IDUTLOCAEMIS IS NOT NULL THEN
            V_DESC := V_DESC || ' UtilLocaEmis=' || :NEW.IDUTLOCAEMIS;
         END IF;

         IF :NEW.IDUTFILILCEM IS NOT NULL THEN
            V_DESC := V_DESC || ' UtilizaFil=' || :NEW.IDUTFILILCEM;
         END IF;

         V_TIPO         := '1';
         V_ITPESQ       := :NEW.CDCTRLNUMENF;
      END IF;
   END IF;

   IF V_TIPO <> '0' THEN
      NMUSUARIO(V_USUARIO);
      IF NOT V_DESC IS NULL THEN
         IF NOT V_USUARIO IS NULL THEN
            V_DTOPER := SYSDATE;

            INSERT INTO LOGOPERA
               (NMTABELA,   DTOPERACAO, NMRESPOPER,
                IDTIPOOPER, CDPESQITEM, DSOPERACAO)
            VALUES
               ('CTRLNUMENF',  V_DTOPER, V_USUARIO,
                V_TIPO,      V_ITPESQ, V_DESC);
         END IF;
      END IF;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('LOG_GER_CTRLNUMENF','4.09.063'); END;
/

